diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/bindings/modulegen__gcc_LP64.py ns-3.33/src/core/bindings/modulegen__gcc_LP64.py
--- ns-3.32/src/core/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
@@ -4910,12 +5108,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): bool ns3::CallbackImpl<bool, std::basic_string<char>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(std::basic_string<char, std::char_traits<char>, std::allocator<char> > arg0) [member operator]
     cls.add_method('operator()', 
                    'bool', 
                    [param('std::string', 'arg0')], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Ns3ObjectBase___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4932,12 +5130,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): ns3::ObjectBase * ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()() [member operator]
     cls.add_method('operator()', 
                    'ns3::ObjectBase *', 
                    [], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4954,12 +5152,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()() [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Unsigned_char___star___Long_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -4976,12 +5174,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned char *, long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(unsigned char * arg0, long int arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('unsigned char *', 'arg0'), param('long int', 'arg1')], 
-                   is_pure_virtual=True, custom_name='__call__', is_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3ConfigMatchContainer_methods(root_module, cls):
@@ -5182,6 +5380,10 @@
     module.add_function('CalculateDistance', 
                         'double', 
                         [param('ns3::Vector3D const &', 'a'), param('ns3::Vector3D const &', 'b')])
+    ## length.h (module 'core'): ns3::Length ns3::CentiMeters(double value) [free function]
+    module.add_function('CentiMeters', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## ptr.h (module 'core'): ns3::Ptr<ns3::EnumChecker> ns3::Create() [free function]
     module.add_function('Create', 
                         'ns3::Ptr< ns3::EnumChecker >', 
@@ -5213,6 +5415,10 @@
     module.add_function('DefaultTimePrinter', 
                         'void', 
                         [param('std::ostream &', 'os')])
+    ## length.h (module 'core'): int64_t ns3::Div(ns3::Length const & numerator, ns3::Length const & denominator, ns3::Length * remainder=nullptr) [free function]
+    module.add_function('Div', 
+                        'int64_t', 
+                        [param('ns3::Length const &', 'numerator'), param('ns3::Length const &', 'denominator'), param('ns3::Length *', 'remainder', default_value='nullptr')])
     ## nstime.h (module 'core'): int64_t ns3::Div(ns3::Time const & lhs, ns3::Time const & rhs) [free function]
     module.add_function('Div', 
                         'int64_t', 
@@ -5227,6 +5433,10 @@
                         'ns3::Ptr< ns3::PairChecker const >', 
                         [param('ns3::Ptr< ns3::AttributeChecker const > const &', 'p')], 
                         template_parameters=['ns3::PairChecker const', ' ns3::AttributeChecker const'])
+    ## length.h (module 'core'): ns3::Length ns3::Feet(double value) [free function]
+    module.add_function('Feet', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## nstime.h (module 'core'): ns3::Time ns3::FemtoSeconds(ns3::int64x64_t value) [free function]
     module.add_function('FemtoSeconds', 
                         'ns3::Time', 
@@ -5235,6 +5445,10 @@
     module.add_function('FemtoSeconds', 
                         'ns3::Time', 
                         [param('uint64_t', 'value')])
+    ## length.h (module 'core'): std::tuple<bool, ns3::Length::Unit> ns3::FromString(std::string unitString) [free function]
+    module.add_function('FromString', 
+                        'std::tuple< bool, ns3::Length::Unit >', 
+                        [param('std::string', 'unitString')])
     ## log.h (module 'core'): ns3::LogComponent & ns3::GetLogComponent(std::string const name) [free function]
     module.add_function('GetLogComponent', 
                         'ns3::LogComponent &', 
@@ -5263,6 +5477,14 @@
     module.add_function('Hours', 
                         'ns3::Time', 
                         [param('double', 'value')])
+    ## length.h (module 'core'): ns3::Length ns3::Inches(double value) [free function]
+    module.add_function('Inches', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
+    ## length.h (module 'core'): ns3::Length ns3::KiloMeters(double value) [free function]
+    module.add_function('KiloMeters', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## log.h (module 'core'): void ns3::LogComponentDisable(char const * name, ns3::LogLevel level) [free function]
     module.add_function('LogComponentDisable', 
                         'void', 
@@ -5327,6 +5549,10 @@
     module.add_function('MakeEvent', 
                         'ns3::EventImpl *', 
                         [param('void ( * ) (  )', 'f')])
+    ## length.h (module 'core'): ns3::Ptr<const ns3::AttributeChecker> ns3::MakeLengthChecker() [free function]
+    module.add_function('MakeLengthChecker', 
+                        'ns3::Ptr< ns3::AttributeChecker const >', 
+                        [])
     ## object-factory.h (module 'core'): ns3::Ptr<const ns3::AttributeChecker> ns3::MakeObjectFactoryChecker() [free function]
     module.add_function('MakeObjectFactoryChecker', 
                         'ns3::Ptr< ns3::AttributeChecker const >', 
@@ -5371,6 +5597,14 @@
     module.add_function('Max', 
                         'ns3::int64x64_t', 
                         [param('ns3::int64x64_t const &', 'a'), param('ns3::int64x64_t const &', 'b')])
+    ## length.h (module 'core'): ns3::Length ns3::Meters(double value) [free function]
+    module.add_function('Meters', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
+    ## length.h (module 'core'): ns3::Length ns3::MicroMeters(double value) [free function]
+    module.add_function('MicroMeters', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## nstime.h (module 'core'): ns3::Time ns3::MicroSeconds(ns3::int64x64_t value) [free function]
     module.add_function('MicroSeconds', 
                         'ns3::Time', 
@@ -5379,6 +5613,14 @@
     module.add_function('MicroSeconds', 
                         'ns3::Time', 
                         [param('uint64_t', 'value')])
+    ## length.h (module 'core'): ns3::Length ns3::Miles(double value) [free function]
+    module.add_function('Miles', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
+    ## length.h (module 'core'): ns3::Length ns3::MilliMeters(double value) [free function]
+    module.add_function('MilliMeters', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## nstime.h (module 'core'): ns3::Time ns3::MilliSeconds(ns3::int64x64_t value) [free function]
     module.add_function('MilliSeconds', 
                         'ns3::Time', 
@@ -5403,6 +5645,14 @@
     module.add_function('Minutes', 
                         'ns3::Time', 
                         [param('double', 'value')])
+    ## length.h (module 'core'): ns3::Length ns3::Mod(ns3::Length const & numerator, ns3::Length const & denominator) [free function]
+    module.add_function('Mod', 
+                        'ns3::Length', 
+                        [param('ns3::Length const &', 'numerator'), param('ns3::Length const &', 'denominator')])
+    ## length.h (module 'core'): ns3::Length ns3::NanoMeters(double value) [free function]
+    module.add_function('NanoMeters', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## nstime.h (module 'core'): ns3::Time ns3::NanoSeconds(ns3::int64x64_t value) [free function]
     module.add_function('NanoSeconds', 
                         'ns3::Time', 
@@ -5411,6 +5661,10 @@
     module.add_function('NanoSeconds', 
                         'ns3::Time', 
                         [param('uint64_t', 'value')])
+    ## length.h (module 'core'): ns3::Length ns3::NauticalMiles(double value) [free function]
+    module.add_function('NauticalMiles', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## simulator.h (module 'core'): ns3::Time ns3::Now() [free function]
     module.add_function('Now', 
                         'ns3::Time', 
@@ -5443,6 +5697,14 @@
     module.add_function('TimeStep', 
                         'ns3::Time', 
                         [param('uint64_t', 'ts')])
+    ## length.h (module 'core'): std::string ns3::ToName(ns3::Length::Unit unit, bool plural=false) [free function]
+    module.add_function('ToName', 
+                        'std::string', 
+                        [param('ns3::Length::Unit', 'unit'), param('bool', 'plural', default_value='false')])
+    ## length.h (module 'core'): std::string ns3::ToSymbol(ns3::Length::Unit unit) [free function]
+    module.add_function('ToSymbol', 
+                        'std::string', 
+                        [param('ns3::Length::Unit', 'unit')])
     ## type-name.h (module 'core'): std::string ns3::TypeNameGet() [free function]
     module.add_function('TypeNameGet', 
                         'std::string', 
@@ -5493,6 +5755,10 @@
                         'std::string', 
                         [], 
                         template_parameters=['double'])
+    ## length.h (module 'core'): ns3::Length ns3::Yards(double value) [free function]
+    module.add_function('Yards', 
+                        'ns3::Length', 
+                        [param('double', 'value')])
     ## nstime.h (module 'core'): ns3::Time ns3::Years(ns3::int64x64_t value) [free function]
     module.add_function('Years', 
                         'ns3::Time', 
@@ -5512,6 +5778,11 @@
     return
 
 def register_functions_ns3_CommandLineHelper(module, root_module):
+    ## command-line.h (module 'core'): std::string ns3::CommandLineHelper::GetDefault(ns3::Time const & val) [free function]
+    module.add_function('GetDefault', 
+                        'std::string', 
+                        [param('ns3::Time const &', 'val')], 
+                        template_parameters=['ns3::Time'])
     ## command-line.h (module 'core'): std::string ns3::CommandLineHelper::GetDefault(bool const & val) [free function]
     module.add_function('GetDefault', 
                         'std::string', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/examples/length-example.cc ns-3.33/src/core/examples/length-example.cc
--- ns-3.32/src/core/examples/length-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/core/examples/length-example.cc	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,153 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathew Bielejeski <bielejeski1@llnl.gov>
+ */
+
+#include "ns3/core-module.h"
+#include "ns3/length.h"
+
+#include <iostream>
+
+/**
+ * \file
+ * \ingroup core-examples
+ * \ingroup length
+ * Demonstrates usage of the ns3::Length class
+ */
+
+using namespace ns3;
+using Unit = Length::Unit;
+
+void Constructors ()
+{
+    double input = 5;
+    Length::Quantity quantity (input, Unit::Meter);
+
+    std::cout << "\nConstructors:"
+              << "\nLength (" << input << ", Unit::Meter) = " << Length (input, Unit::Meter)
+              << "\nLength (" << input << ", \"m\") = " << Length (input, "m")
+              << "\nLength (" << input << ", \"meter\") = " << Length (input, "meter")
+              << "\nLength (Quantity(" << input << ", Unit::Meter)) = " << Length (quantity)
+              << "\nLength (\"5m\") = " << Length ("5m")
+              << "\nLength (\"5 m\") = " << Length ("5 m")
+              << "\nLength (\"5meter\") = " << Length ("5meter")
+              << "\nLength (\"5 meter\") = " << Length ("5 meter")
+              << "\nLength (\"5meters\") = " << Length ("5meters")
+              << "\nLength (\"5 meters\") = " << Length ("5 meters")
+              << std::endl;
+}
+
+void Conversions ()
+{
+  //construct length using value and unit
+  Length moonDistance (3.84402e8, Unit::Meter);
+
+  //Demonstrate conversion to various units
+  std::cout << "\nConversions: "
+            << "\nDistance to moon = " << moonDistance
+            << "\nIn Feet: " << moonDistance.As (Unit::Foot)
+            << "\nIn Miles: " << moonDistance.As (Unit::Mile)
+            << "\nIn Kilometers: " << moonDistance.As (Unit::Kilometer)
+            << std::endl;
+}
+
+void ArithmeticOperators ()
+{
+  double scale = 10;
+
+  //construct lengths using helper functions
+  Length oneMeter = Meters (1);
+  Length twoMeter = Meters (2);
+
+  std::cout << "\nArithmetic Operations:"
+            << "\nAddition: " << oneMeter << " + " << oneMeter << " = "
+            << (oneMeter + oneMeter)
+            << "\nSubtraction: " << oneMeter << " - " << oneMeter << " = "
+            << (oneMeter - oneMeter)
+            << "\nMultiplication By Scalar: " << oneMeter << " * " << scale << " = "
+            << (oneMeter * scale)
+            << "\nDivision: " << oneMeter << " / " << twoMeter << " = "
+            << (oneMeter / twoMeter)
+            << "\nDivision By Scalar: " << oneMeter << " / " << scale << " = "
+            << (oneMeter / scale)
+            << std::endl;
+
+}
+
+void EqualityOperators ()
+{
+  Length oneMeter = Meters (1);
+  Length twoMeter = Meters (2);
+  Length threeMeter = Meters (3);
+
+  std::cout << "\nComparison Operations:" << std::boolalpha
+            << "\nEquality: " << oneMeter << " == " << oneMeter << " is "
+            << (oneMeter == oneMeter)
+            << "\nEquality: " << oneMeter << " == " << twoMeter << " is "
+            << (oneMeter == twoMeter)
+            << "\nInequality: " << oneMeter << " != " << oneMeter << " is "
+            << (oneMeter != oneMeter)
+            << "\nInequality: " << oneMeter << " != " << twoMeter << " is "
+            << (oneMeter != twoMeter)
+            << "\nLesser: "   << oneMeter << " < " << oneMeter << " is "
+            << (oneMeter < oneMeter)
+            << "\nLesser: "   << oneMeter << " < " << twoMeter << " is "
+            << (oneMeter < twoMeter)
+            << "\nLesser: "   << threeMeter << " < " << oneMeter << " is "
+            << (threeMeter < oneMeter)
+            << "\nGreater: "  << oneMeter << " > " << oneMeter << " is "
+            << (oneMeter > oneMeter)
+            << "\nGreater: "  << oneMeter << " > " << twoMeter << " is "
+            << (oneMeter > twoMeter)
+            << "\nGreater: "  << threeMeter << " > " << oneMeter << " is "
+            << (threeMeter > oneMeter)
+            << std::endl;
+}
+
+void DivAndMod ()
+{
+  //construct length using helper function
+  Length totalLen = Feet (20);
+  Length pieceLen = Feet (3);
+  Length remainder;
+
+  int64_t count = Div (totalLen, pieceLen, &remainder);
+
+  std::cout << "\nHow many times can a " << totalLen.As (Unit::Foot) << " length "
+            << "be split into " << pieceLen.As (Unit::Foot) << " sized pieces? "
+            << count
+            << "\nremainder: " << remainder.As (Unit::Foot)
+            << std::endl;
+
+  std::cout << "\nHow much remains after splitting a "
+            << totalLen.As (Unit::Foot) << " length into "
+            << pieceLen.As (Unit::Foot) << " sized pieces? "
+            << Mod (totalLen, pieceLen).As (Unit::Foot)
+            << std::endl;
+}
+
+int main (int argc, char** argv)
+{
+  Constructors ();
+  Conversions ();
+  ArithmeticOperators ();
+  EqualityOperators ();
+  DivAndMod ();
+
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/examples/wscript ns-3.33/src/core/examples/wscript
--- ns-3.32/src/core/examples/wscript	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/examples/wscript	2021-01-09 10:19:22.000000000 -0800
@@ -64,3 +64,5 @@
         obj = bld.create_ns3_program('main-test-sync', ['network'])
         obj.source = 'main-test-sync.cc'
 
+    obj = bld.create_ns3_program('length-example', ['core'])
+    obj.source = 'length-example.cc'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/helper/csv-reader.cc ns-3.33/src/core/helper/csv-reader.cc
--- ns-3.32/src/core/helper/csv-reader.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/core/helper/csv-reader.cc	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,480 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathew Bielejeski <bielejeski1@llnl.gov>
+ */
+
+#include "csv-reader.h"
+
+#include "ns3/log.h"
+
+#include <algorithm>
+#include <cctype>
+#include <fstream>
+#include <iterator>
+#include <sstream>
+#include <vector>
+
+/**
+ * \file
+ * \ingroup core
+ * \ingroup csvreader
+ *
+ * ns3::CsvReader implementation
+ */
+
+NS_LOG_COMPONENT_DEFINE ("CsvReader");
+
+namespace {
+
+/**
+ * Convert a string into another type.
+ *
+ * Uses a stringstream to deserialize the value stored in \p input
+ * to a value of type T and writes the deserialized value to \p output.
+ *
+ * \tparam T Data type of output.
+ * \param input String containing serialized data.
+ * \param output Place to store deserialized value.
+ *
+ * \return \c true if deserialization was successful, \c false otherwise.
+ */
+template<typename T>
+bool GenericTransform (std::string input, T& output)
+{
+  NS_LOG_FUNCTION (input);
+
+  std::istringstream stream (input);
+
+  stream >> output;
+
+  return static_cast<bool> (stream);
+}
+
+}   // unnamed namespace
+
+namespace ns3 {
+
+CsvReader::CsvReader (const std::string& filepath, char delimiter /* =',' */)
+  : m_delimiter (delimiter),
+    m_rowsRead (0),
+    m_fileStream (filepath),
+    m_stream (&m_fileStream)
+{
+  NS_LOG_FUNCTION (this << filepath);
+}
+
+CsvReader::CsvReader (std::istream& stream, char delimiter /* =',' */)
+  : m_delimiter (delimiter),
+    m_rowsRead (0),
+    m_fileStream (),
+    m_stream (&stream)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+CsvReader::~CsvReader ()
+{}
+
+std::size_t
+CsvReader::ColumnCount () const
+{
+  NS_LOG_FUNCTION (this);
+
+  return m_columns.size ();
+}
+
+std::size_t
+CsvReader::RowNumber () const
+{
+  NS_LOG_FUNCTION (this);
+
+  return m_rowsRead;
+}
+
+char
+CsvReader::Delimiter () const
+{
+  NS_LOG_FUNCTION (this);
+
+  return m_delimiter;
+}
+
+bool
+CsvReader::FetchNextRow ()
+{
+  NS_LOG_FUNCTION (this);
+
+  std::string line;
+
+  if ( m_stream->eof () )
+    {
+      NS_LOG_LOGIC ("Reached end of stream");
+      return false;
+    }
+
+  NS_LOG_LOGIC ("Reading line " << m_rowsRead + 1);
+
+  std::getline (*m_stream, line);
+
+  if ( m_stream->fail () )
+    {
+      NS_LOG_ERROR ("Reading line " << m_rowsRead + 1 << " failed");
+
+      return false;
+    }
+
+  ++m_rowsRead;
+
+  ParseLine (line);
+
+  return true;
+}
+
+bool
+CsvReader::IsBlankRow () const
+{
+  return m_blankRow;
+}
+
+bool
+CsvReader::GetValueAs (std::string input, double& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, float& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, signed char& value) const
+{
+  typedef signed char byte_type;
+
+  NS_LOG_FUNCTION (this << input);
+
+  std::istringstream tempStream (input);
+
+  std::int16_t tempOutput = 0;
+  tempStream >> tempOutput;
+
+  if (tempOutput >= std::numeric_limits<byte_type>::min ()
+      || tempOutput <= std::numeric_limits<byte_type>::max () )
+    {
+      value = static_cast<byte_type> (tempOutput);
+    }
+
+  bool success = static_cast<bool> (tempStream);
+
+  NS_LOG_DEBUG ("Input='" << input
+                          << "', output=" << tempOutput
+                          << ", result=" << success);
+
+  return success;
+}
+
+bool
+CsvReader::GetValueAs (std::string input, short& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, int& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, long& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, long long& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, std::string& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  value = input;
+
+  return true;
+}
+
+bool
+CsvReader::GetValueAs (std::string input, unsigned char& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  typedef unsigned char byte_type;
+
+  NS_LOG_FUNCTION (this << input);
+
+  std::istringstream tempStream (input);
+
+  std::uint16_t tempOutput = 0;
+  tempStream >> tempOutput;
+
+  if (tempOutput >= std::numeric_limits<byte_type>::min ()
+      || tempOutput <= std::numeric_limits<byte_type>::max () )
+    {
+      value = static_cast<byte_type> (tempOutput);
+    }
+
+  bool success = static_cast<bool> (tempStream);
+
+  NS_LOG_DEBUG ("Input='" << input
+                          << "', output=" << tempOutput
+                          << ", result=" << success);
+
+  return success;
+}
+
+bool
+CsvReader::GetValueAs (std::string input, unsigned short& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, unsigned int& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, unsigned long& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::GetValueAs (std::string input, unsigned long long& value) const
+{
+  NS_LOG_FUNCTION (this << input);
+
+  return GenericTransform (std::move (input), value);
+}
+
+bool
+CsvReader::IsDelimiter (char c) const
+{
+  NS_LOG_FUNCTION (this << c);
+
+  return c == m_delimiter;
+}
+
+void
+CsvReader::ParseLine (const std::string& line)
+{
+  NS_LOG_FUNCTION (this << line);
+
+  std::string value;
+  m_columns.clear ();
+
+  auto start_col = line.begin ();
+  auto end_col = line.end ();
+
+  while ( start_col != line.end () )
+    {
+      std::tie (value, end_col) = ParseColumn (start_col, line.end ());
+
+      NS_LOG_DEBUG ("ParseColumn() returned: " << value);
+
+      m_columns.push_back (std::move (value));
+
+      if ( end_col != line.end () )
+        {
+          ++end_col;
+        }
+
+      start_col = end_col;
+    }
+  m_blankRow = (m_columns.size () == 1) && (m_columns[0] == "");
+  NS_LOG_LOGIC ("blank row: " << m_blankRow);
+}
+
+std::tuple<std::string, std::string::const_iterator>
+CsvReader::ParseColumn (std::string::const_iterator begin, std::string::const_iterator end)
+{
+  NS_LOG_FUNCTION (this << std::string (begin, end));
+
+  enum class State
+  {
+    BEGIN,
+    END_QUOTE,
+    FIND_DELIMITER,
+    QUOTED_STRING,
+    UNQUOTED_STRING,
+    END
+  };
+
+  State state = State::BEGIN;
+  std::string buffer;
+  auto iter = begin;
+
+  while (state != State::END)
+    {
+      if (iter == end)
+        {
+          NS_LOG_DEBUG ("Found end iterator, switching to END state");
+
+          state = State::END;
+          continue;
+        }
+
+      auto c = *iter;
+
+      NS_LOG_DEBUG ("Next character: '" << c << "'");
+
+      //handle common cases here to avoid duplicating logic
+      if (state != State::QUOTED_STRING)
+        {
+          if (IsDelimiter (c))
+            {
+              NS_LOG_DEBUG ("Found field delimiter, switching to END state");
+
+              if ( state == State::UNQUOTED_STRING )
+                {
+                  NS_LOG_DEBUG ("Removing trailing whitespace from unquoted field: '" << buffer << "'");
+                  auto len = buffer.size ();
+
+                  //remove trailing whitespace from the field
+                  while ( !buffer.empty ()
+                          && std::isspace (static_cast<unsigned char> (buffer.back ())) )
+                    {
+                      buffer.pop_back ();
+                    }
+
+                  auto finalLen = buffer.size ();
+
+                  NS_LOG_DEBUG ("Removed " << (len - finalLen) << " trailing whitespace characters");
+                }
+
+              state = State::END;
+
+              continue;
+            }
+          else if (c == '#')
+            {
+              NS_LOG_DEBUG ("Found start of comment, switching to END state");
+
+              //comments consume the rest of the line, set iter to end
+              //to reflect that fact.
+              iter = end;
+              state = State::END;
+
+              continue;
+            }
+        }
+
+      switch (state)
+        {
+          case State::BEGIN:
+            {
+              if (c == '"')
+                {
+                  NS_LOG_DEBUG ("Switching state: BEGIN -> QUOTED_STRING");
+
+                  state = State::QUOTED_STRING;
+                }
+              else if (!std::isspace (c))
+                {
+                  NS_LOG_DEBUG ("Switching state: BEGIN -> UNQUOTED_STRING");
+
+                  state = State::UNQUOTED_STRING;
+                  buffer.push_back (c);
+                }
+
+            } break;
+          case State::QUOTED_STRING:
+            {
+              if (c == '"')
+                {
+                  NS_LOG_DEBUG ("Switching state: QUOTED_STRING -> END_QUOTE");
+                  state = State::END_QUOTE;
+                }
+              else
+                {
+                  buffer.push_back (c);
+                }
+
+            } break;
+          case State::END_QUOTE:
+            {
+              if (c == '"')
+                {
+                  NS_LOG_DEBUG ("Switching state: END_QUOTE -> QUOTED_STRING" );
+
+                  //an escape quote instead of an end quote
+                  state = State::QUOTED_STRING;
+                  buffer.push_back (c);
+                }
+              else
+                {
+                  NS_LOG_DEBUG ("Switching state: END_QUOTE -> FIND_DELIMITER" );
+                  state = State::FIND_DELIMITER;
+                }
+
+            } break;
+          case State::UNQUOTED_STRING:
+            {
+              buffer.push_back (c);
+            } break;
+          case State::FIND_DELIMITER:
+            break;
+          case State::END:
+            break;
+        }
+
+      ++iter;
+    }
+
+  NS_LOG_DEBUG ("Field value: " << buffer);
+
+  return std::make_tuple (buffer, iter);
+}
+
+}   // namespace ns3
+
